/* --------------------------------------------------------------------------------
 #
 #	4DPlugin.c
 #	source generated by 4D Plugin Wizard
 #	Project : PictureContainer
 #	author : Thomas
 #	18.09.2005
 #
 # --------------------------------------------------------------------------------*/


#include "4DPluginAPI.h"
#include "4DPlugin.h"

#if VERSIONWIN
#include <Windows.h>
#endif

#include "ImageRoutinen.h"

void PluginMain( long selector, PA_PluginParameters params )
{
	switch( selector )
	{
		case kInitPlugin :
			InitPlugin();
			break;

		case kDeinitPlugin :
			DeinitPlugin();
			break;

// --- Picture_Container

		case eCMD_PC_Set_Picture :
			Load4DPicture( params );
			break;

		case eCMD_PC_Set_Blob :
			LoadPictureBlob( params );
			break;

		case eCMD_PC_Set_Path :
			LoadPictureFile( params );
			break;

		case eCMD_PC_Set_Prop :
			SetDisplayProperties( params );
			break;

		case eCMD_PC_Get_Prop :
			GetDisplayProperties( params );
			break;

		case eCMD_PC_Get_Format :
			GetPictureProperties( params );
			break;

		case eCMD_PC_Get_Thumbnail :
			GetThumbnail( params );
			break;

		case eCMD_PC_ClearPicture:
			ClearPicture(params);
			break;

		case eCMD_PC_NewOffscreen:
			NewOffscreen(params);
			break;

		case eCMD_PC_DeleteOffscreen:
			DeleteOffscreen(params);
			break;

		case eCMD_PC_SavePicture:
			Save4DPicture(params);
			break;

		case eCMD_PC_SaveBlob:
			SavePictureBlob(params);
			break;

		case eCMD_PC_SaveFile:
			SavePictureFile(params);
			break;

		case eCMD_PC_GetModified:
			GetAreaModified(params);
			break;

		case eCMD_PC_AllowDrop:
			AreaAllowNextDrop(params);
			break;
			
		case eCMD_PC_AreaProperties:
			SetAreaProperties(params);
			break;

			// --- External areas

		case eCMD_PC_Area :
			PictContainer( params );
			break;

	}
}



// -------------------------------- External Areas --------------------------------


void PictContainer( PA_PluginParameters params )
{
	PA_AreaEvent event;

	event = PA_GetAreaEvent( params );
	
	switch ( event )
	{
	// --- Initialisation
		case eAE_InitArea :
			InitArea( params );
			break;

		case eAE_InitAdvancedProperties :
			PreInitArea( params );  //  bug?? ACI0026601
			//  does not work...   
			//PA_DontTakeEvent( params );  // sho eAE_InitArea will still be called.
		
			// next try. let's call Init ourself...
			// it seems that GetAvancesProperties removes all Init calls...
			InitArea( params );
			break;

	// --- Deinitialisation
		case eAE_Deinit :
			DeinitArea( params);
			// free any privateData allocated at init
			break;

	// --- switch page
		case eAE_PageChange :
			AreaChangeFormPage( params);
			break;

	// --- Update in layout editor
		case eAE_DesignUpdate :
			AreaStructure( params );
			PA_CustomizeDesignMode( params );
			break;

	// --- Mouse down event
		case eAE_MouseDown :
			AreaMouseClick(params);		
			break;

		case eAE_MouseWheel:
			AreaWheel(params);			
			break;

		case eAE_Update :
		case eAE_Scroll :
			AreaUpdate( params );
			break;

		case eAE_Cursor :
			PA_DontTakeEvent( params );
			break;

	// --- Drag&Drop
		case eAE_AllowDrop :
			AllowDrop(params);
			break;
		case eAE_Drag :
			;
			break;		
		case eAE_Drop :
			 AreaDrop(params);
			break;

		case eAE_EndExecutionCycle :
			CheckRedrawRequired(params);
			break;

	// Auto Load/Save
		case eAE_LoadRecord :
				LoadAssignedField(params);
			break;

		case eAE_SaveRecord :
				SaveAssignedField(params);
			break;

	// Select/Deselect

		case eAE_IsFocusable:
			PA_SetAreaFocusable(params, 1);
			break;

		case eAE_Select :
			PA_AcceptSelect(params, 1);
			break;

		case eAE_Deselect :
			PA_AcceptDeselect(params, 1);
			break;


	// Edit Menu
		case eAE_UpdateEditCommands :
			SetEditMenu(params);
			break;

		case eAE_CutCommand :
			CopyPictureArea(params);
			ClearPictureArea(params);
			break;

		case eAE_CopyCommand :
			CopyPictureArea(params);
			break;

		case eAE_PasteCommand :
			PastePictureArea(params);
			break;

		case eAE_ClearCommand :
			ClearPictureArea(params);
			break;

		default  :
			PA_DontTakeEvent( params );
			break;

	}
}


