// --- Imageroutinen
	
#ifdef __cplusplus

#if VERSIONWIN
	#ifndef _WIN32_WINNT
		#define _WIN32_WINNT 0x0500  //  needed for WM_MOUSEWHEEL
	#endif

	#include <Windows.h>
	#include <gdiplus.h>
	using namespace Gdiplus;
	#include <stdio.h>
	#include <malloc.h>
	#include <string.h>
	#include <Winuser.h>
#else
	#include <Carbon/Carbon.h>
	#include <QuickTime/QuickTime.h>
#endif

#include "ImageTypes.h"

extern "C" {
#endif

 #define kMINIMAL_4DVERSION   0x00000700
 #define kAreaTag			  'TMPC'

#define kError_unknownArea 15001
#define kError_4DPack 15002
#define kError_Thumbnail 15003


	void InitPlugin(void);
	void DeinitPlugin(void);

	// --- Area Image
	void PreInitArea(PA_PluginParameters params);
	void InitArea(PA_PluginParameters params);
	void DeinitArea(PA_PluginParameters params);
	void AreaUpdate(PA_PluginParameters params);
	void AreaStructure(PA_PluginParameters params);
	void AreaChangeFormPage(PA_PluginParameters params);
	void CheckRedrawRequired(PA_PluginParameters params);
	void AreaMouseClick(PA_PluginParameters params);
	void AreaWheel( PA_PluginParameters params );
	void AllowDrop(PA_PluginParameters params);
	void AreaDrop(PA_PluginParameters params);
	void LoadAssignedField( PA_PluginParameters params);
	void SaveAssignedField( PA_PluginParameters params);
	void ClearPictureArea( PA_PluginParameters params );
	void CopyPictureArea( PA_PluginParameters params );
	void PastePictureArea( PA_PluginParameters params );
	void SetEditMenu(PA_PluginParameters params );

	// --- GDIPlus_Image
	void LoadPictureFile( PA_PluginParameters params );
	void Load4DPicture(PA_PluginParameters params );		
	void LoadPictureBlob( PA_PluginParameters params );
	void SetDisplayProperties( PA_PluginParameters params );
	void GetDisplayProperties( PA_PluginParameters params );
	void GetPictureProperties( PA_PluginParameters params );
	void GDI_SetDisplayMode( PA_PluginParameters params );
	void GetThumbnail( PA_PluginParameters params );
	void ClearPicture( PA_PluginParameters params );
	void NewOffscreen(PA_PluginParameters params);
	void DeleteOffscreen(PA_PluginParameters params);
	void SavePictureBlob( PA_PluginParameters params );
	void Save4DPicture( PA_PluginParameters params );
	void SavePictureFile( PA_PluginParameters params );
	void GetAreaModified(PA_PluginParameters params );
	void AreaAllowNextDrop(PA_PluginParameters params );
	void SetAreaProperties(PA_PluginParameters params);


#ifdef __cplusplus
}
#endif
