typedef struct  {   /* Record fr Area */
	long TAG;  
	long ZoomX, ZoomY;
	long ScrollX, ScrollY;
	#if VERSIONWIN
		Image*			image;
		LPSTREAM		pStream;
		HWND			FormWindow;
		HWND			HorScroll, VertScroll;
		WNDPROC			wpOrigWinProc;
		HDC				fWinHDC;
	#else
		WindowRef		FormWindow;
		CGrafPtr		fMacPort;
		PicHandle		image;
		long			PictWidth, PictHeight;
		short			PictDepth;
		Str31			Format;
		float			PictResX, PictResY;
		ControlRef		HorScroll, VertScroll;
		ControlActionUPP	myControlActionUPP;
	#endif
	PA_Rect oldSize;
	long AreaProcess;
	short FormPage;
short TableNumber;
bool AllowDrag, AllowDrop, AutoDrop, AllowCopy, AllowPaste;
	bool HScrollShow, HScrollActive, VScrollShow, VScrollActive; 
	bool RedrawRequired, Dirty, AllowNextDrop;
	bool Offscreen;
}ImageAreaStruct;

// --- GDI_ScalePicture
#define GDI_ScaledToFit	-2
#define GDI_ScaledToFitPropCentered	-1
#define GDI_ScaledToFitProp	0
#define GDI_ReduceToFitPropCentered	-3
#define GDI_ReduceToFitProp	-4

#define kErr_MemError -108

#if VERSIONWIN
#define AreaScrollbarSize 16
#else
#define AreaScrollbarSize 15
#endif

#if VERSIONWIN
	LRESULT CALLBACK ScrollWndProc(HWND hwnd,  UINT uMsg, WPARAM wParam, LPARAM lParam);  
	void DoScrollAction(ImageAreaStruct *AreaHandle,  HWND hwnd,  UINT uMsg, WPARAM wParam, LPARAM lParam);
	void DrawImage(ImageAreaStruct *AreaData, HDC hdc, PA_Rect myrect);
	void ConvertPA_RectToRect(PA_Rect source, RECT *dest);
	int GetEncoderClsid(const WCHAR* format, CLSID* pClsid);
	int GetEncoderClsid(char * format, CLSID &pngClsid);
	long BMPtoMacPictParam(char *pBuff, int theSize, PA_PluginParameters params, short index, short tNum, short fNum, char UsePictVariable);
#else
	void MyScrollbarActionProc(ControlRef theControl, ControlPartCode partCode);
	void DrawImage(ImageAreaStruct *AreaData, PA_Rect myrect);
	void DrawImageSub_Mac(ImageAreaStruct *AreaHandle, PA_Rect myrect, long SizeX, long SizeY);
	OSErr build_4DPath_2_PosixPath (char* Pfad , char *NewPath , UInt8 *newPathUTF8 , CFIndex buffSize  );
	long build_FSSpecFrompathNewfile ( char* thePath, FSSpec *myFSSpec);
	long build_FSSpecFrompath ( char* thePath, FSSpec *myFSSpec);
	void DoMacScroll(ImageAreaStruct *AreaHandle, short xDelta, short yDelta);
	void StorePictureInformations(ImageAreaStruct *AreaHandle, GraphicsImportComponent gi);
	OSType GetEncoderType(char * format);
	long GetCompression(long compression);
#endif

void GetScaledImageSize(ImageAreaStruct *AreaData, long &ImageSizeX, long &ImageSizeY, long SpaceX, long SpaceY);
void InitAreaObjects(ImageAreaStruct *AreaHandle);
long CheckAssignedField( PA_PluginParameters params,  bool structurecall );
long Load4DPictureInHandle(ImageAreaStruct *AreaHandle, PA_Handle thePict );
long LoadBlobInHandle( PA_PluginParameters params, PA_Handle theBlob );
void ClearImage(ImageAreaStruct *AreaHandle );
void CheckDragOut(PA_PluginParameters params);
long SavePictureFile( ImageAreaStruct *AreaHandle, char * Pfad, char * format, long compression );
#if VERSIONWIN
long Save4DPicture( ImageAreaStruct *AreaHandle, PA_PluginParameters params, short index, short tNum, short fNum, char UsePictVariable);
#else
long Save4DPicture( ImageAreaStruct *AreaHandle, PA_PluginParameters params, short index, short tNum, short fNum, char UsePictVariable = 0);
#endif
long SavePictureBlob(ImageAreaStruct *AreaHandle, PA_PluginParameters params, char * format, long compression, short index, short tNum, short fNum);

short PA_GetModifiers( PA_PluginParameters params );